/*-------------------------------------------------------------------------+
| Copyright 2020 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.kernel.ui.introspection;

import org.fortiss.tooling.common.ui.javafx.layout.CompositeFXControllerBase;
import org.fortiss.tooling.kernel.service.IKernelIntrospectionSystemService;

import javafx.fxml.FXML;
import javafx.scene.Node;
import javafx.scene.control.TextArea;
import javafx.scene.control.TextField;
import javafx.scene.layout.AnchorPane;
import javafx.scene.layout.BorderPane;

/**
 * Controller for the KISS console view.
 * 
 * @author munaro
 */
@SuppressWarnings("unchecked")
public class KISSConsoleFXController extends CompositeFXControllerBase<AnchorPane, Node> {

	/** {@link BorderPane} containing both the {@link TextArea} and the {@link TextField}. */
	@FXML
	private BorderPane borderPane;

	/** The displayed console content area. */
	@FXML
	private TextArea textArea;

	/** The input text field. */
	@FXML
	private TextField textField;

	/** The introspection service. */
	private IKernelIntrospectionSystemService kiss;

	/** {@inheritDoc} */
	@Override
	public String getFXMLLocation() {
		return "KISSConsole.fxml";
	}

	/** Executes the command entered in the text field. */
	@FXML
	private void onTextFieldAction() {
		String cmd = textField.getText();
		// kiss.executeConsoleCommand(cmd);
		textField.setText("");
	}

	/** {@inheritDoc} */
	@Override
	public void initialize() {
		kiss = IKernelIntrospectionSystemService.getInstance();
		// textArea.setText(kiss.getConsoleContent());
	}
}
